<?php
require_once('controller.php');
require_once('application/models/ajax.php');
require_once('application/models/func.php');
require_once('application/models/temp.php');

class Base extends Controller
{
	public $F = null;
	
	public $key = null;
	
	public $auth = null;
	
	public $title = null;
	
	public $content = null;

	function __construct()
	{
		$this->key = false;
		$this->auth = false;
	}

	function OnInput()
	{
		$this->F = mFunc::instance();
		
		/*  
		if ($this->key)
		{
			$this->F->CheckKey();
		}
		*/
		
		if ($this->auth)
		{
			if (!$this->F->Auth())
			{
				$url = $this->F->CreateUrl('login/');
				header('Location: ' . $url);
				exit();
			}
		}
		
		$this->title = '';
		$this->content = '';
	}

	function OnOutput()
	{
		$vars = array(
			'title'		=> $this->title,
			'content'	=> $this->content,
			'T'			=> $this->T
		);
		
		$page = $this->Template('base', $vars);
		
		echo $page;
	}
}

?>