<?php
class mAjax
{
	protected $F = null;

	function Instance()
	{
		if (is_null($instance))
		{
			$instance = new mAjax();
		}
		
		return $instance;
	}

	function __construct()
	{
		$this->F = mFunc::instance();
		$this->Z = new ZipArchive();
	}

	function __clone()
	{
	
	}

	function GetConfig()
	{
		$languages = array(	'ar', 'bg', 'id', 'ca', 'cs', 'sr', 'da', 'de', 'en', 'es', 'fr', 'it', 
							'lv', 'lt', 'hu', 'nl', 'no', 'pl', 'br', 'hr', 'ro', 'sk', 'sl', 'fi', 
							'sv', 'ru', 'th', 'tl', 'tr', 'uk', 'el', 'iw', 'hi', 'vi', 'cn', 'b5', 'jp', 'kr');
		array_push($languages, $this->F->config['LANGUAGE']);
		$languages = array_unique($languages);
		$templates = glob('templates/*', GLOB_ONLYDIR);
		foreach ($templates as $t => $template)
		{
			$templates[$t] = pathinfo($template, PATHINFO_FILENAME);
		}

		unset($templates[array_search('admin', $templates)]);
		array_push($templates, $this->F->config['TEMPLATE']);
		$templates = array_unique($templates);
		$html = '<table>
	<tr>
		<td class="key"><a href="#">TITLE</a></td>
		<td class="value"><input type="text" name="TITLE" value="' . $this->F->config['TITLE'] . '" onchange="SetConfig(this)"><i class="status"></i></td>
	</tr>
	<tr>
		<td class="key"><a href="#">KEYWORD</a></td>
		<td class="value"><input type="text" name="KEYWORD" value="' . $this->F->config['KEYWORD'] . '" onchange="SetConfig(this)"><i class="status"></i></td>
	</tr>';
		$html .= '	<tr>
		<td class="key"><a href="#">LANGUAGE</a></td>
		<td class="value">
			<select name="LANGUAGE" onchange="SetConfig(this)">';
		
		foreach ($languages as $language)
		{
			$html .= '<option>' . $language . '</option>';
		}

		$html .= '			</select>
			<i class="status"></i>
		</td>
	</tr>
	<tr>
		<td class="key"><a href="#">TEMPLATE</a></td>
		<td class="value">
			<select name="TEMPLATE" onchange="SetConfig(this)">';
		
		foreach ($templates as $template)
		{
			$html .= '<option>' . $template . '</option>';
		}

		$html .= '			</select>
			<i class="status"></i>
		</td>
	</tr>
	<tr>
		<td class="key"><a href="#">COUNT_SNIPPETS</a></td>
		<td class="value"><input type="text" name="COUNT_SNIPPETS" value="' . $this->F->config['COUNT_SNIPPETS'] . '" onchange="SetConfig(this)"><i class="status"></i></td>
	</tr>
	<tr>
		<td class="key"><a href="#">COUNT_LINKS</a></td>
		<td class="value"><input type="text" name="COUNT_LINKS" value="' . $this->F->config['COUNT_LINKS'] . '" onchange="SetConfig(this)"><i class="status"></i></td>
	</tr>
	<tr>
		<td class="key"><a href="#">COUNT_FILES</a></td>
		<td class="value"><input type="text" name="COUNT_FILES" value="' . $this->F->config['COUNT_FILES'] . '" onchange="SetConfig(this)"><i class="status"></i></td>
	</tr>
	<tr>
		<td class="key"><a href="#">WORDS</a></td>
		<td class="value"><input type="text" name="WORDS" value="' . $this->F->config['WORDS'] . '" onchange="SetConfig(this)"><i class="status"></i></td>
	</tr>';
		$true = ($this->F->config['SEARCH'] ? 'checked' : '');
		$false = ($this->F->config['SEARCH'] ? '' : 'checked');
		$html .= '	<tr>
		<td class="key"><a href="#">SEARCH</a></td>
		<td class="value">
			<input id="SEARCH true" class="radio" type="radio" name="SEARCH" value="true" onchange="SetConfig(this)" ' . $true . '><label for="SEARCH true"></label><span>true</span>
			<input id="SEARCH false" class="radio" type="radio" name="SEARCH" value="false" onchange="SetConfig(this)" ' . $false . '><label for="SEARCH false"></label><span>false</span>
		</td>
	</tr>';
		$true = ($this->F->config['STOP_GROWING'] ? 'checked' : '');
		$false = ($this->F->config['STOP_GROWING'] ? '' : 'checked');
		$html .= '	<tr>
		<td class="key"><a href="#">STOP_GROWING</a></td>
		<td class="value">
			<input id="STOP_GROWING true" class="radio" type="radio" name="STOP_GROWING" value="true" onchange="SetConfig(this)" ' . $true . '><label for="STOP_GROWING true"></label><span>true</span>
			<input id="STOP_GROWING false" class="radio" type="radio" name="STOP_GROWING" value="false" onchange="SetConfig(this)" ' . $false . '><label for="STOP_GROWING false"></label><span>false</span>
		</td>
	</tr>';
		$true = ($this->F->config['SUBJECT_LIMITATION'] ? 'checked' : '');
		$false = ($this->F->config['SUBJECT_LIMITATION'] ? '' : 'checked');
		$html .= '	<tr>
		<td class="key"><a href="#">SUBJECT_LIMITATION</a></td>
		<td class="value">
			<input id="SUBJECT_LIMITATION true" class="radio" type="radio" name="SUBJECT_LIMITATION" value="true" onchange="SetConfig(this)" ' . $true . '><label for="SUBJECT_LIMITATION true"></label><span>true</span>
			<input id="SUBJECT_LIMITATION false" class="radio" type="radio" name="SUBJECT_LIMITATION" value="false" onchange="SetConfig(this)" ' . $false . '><label for="SUBJECT_LIMITATION false"></label><span>false</span>
		</td>
	</tr>';
		$true = $this->F->config['ONLY_EXISTING_KEYWORDS'] ? 'checked' : '';
		$false = $this->F->config['ONLY_EXISTING_KEYWORDS'] ? '' : 'checked';
		$html .= '	<tr>
		<td class="key"><a href="#">ONLY_EXISTING_KEYWORDS</a></td>
		<td class="value">
			<input id="ONLY_EXISTING_KEYWORDS true" class="radio" type="radio" name="ONLY_EXISTING_KEYWORDS" value="true" onchange="SetConfig(this)" ' . $true . '><label for="ONLY_EXISTING_KEYWORDS true"></label><span>true</span>
			<input id="ONLY_EXISTING_KEYWORDS false" class="radio" type="radio" name="ONLY_EXISTING_KEYWORDS" value="false" onchange="SetConfig(this)" ' . $false . '><label for="ONLY_EXISTING_KEYWORDS false"></label><span>false</span>
		</td>
	</tr>';
		$html .= '	<tr>
		<td class="key"><a href="#">ROUTE</a></td>
		<td class="value"><input type="text" name="ROUTE" value="' . $this->F->config['ROUTE'] . '" onchange="SetConfig(this)"><i class="status"></i></td>
	</tr>';
		$full = $this->F->config['FU_TYPE'] ? 'checked' : '';
		$rand = $this->F->config['FU_TYPE'] ? '' : 'checked';
		$html .= '	<tr>
		<td class="key"><a href="#">FU_TYPE</a></td>
		<td class="value">
			<input id="FU_TYPE full" class="radio" type="radio" name="FU_TYPE" value="FULL" onchange="SetConfig(this)" ' . $full . '><label for="FU_TYPE full"></label><span>full</span>
			<input id="FU_TYPE rand" class="radio" type="radio" name="FU_TYPE" value="RAND" onchange="SetConfig(this)" ' . $rand . '><label for="FU_TYPE rand"></label><span>rand</span>
		</td>
	</tr>';
		$html .= '	<tr>
		<td class="key"><a href="#">FU_EXTENSION</a></td>
		<td class="value"><input type="text" name="FU_EXTENSION" value="' . $this->F->config['FU_EXTENSION'] . '" onchange="SetConfig(this)"><i class="status"></i></td>
	</tr>';
		$http = $this->F->config['PROXY'] == 'HTTP' ? 'checked' : '';
		$socks = $this->F->config['PROXY'] == 'SOCKS' ? 'checked' : '';
		$html .= '	<tr>
		<td class="key"><a href="#">PROXY</a></td>
		<td class="value">
			<input id="PROXY http" class="radio" type="radio" name="PROXY" value="HTTP" onchange="SetConfig(this)" ' . $http . '><label for="PROXY http"></label><span>http</span>
			<input id="PROXY socks" class="radio" type="radio" name="PROXY" value="SOCKS" onchange="SetConfig(this)" ' . $socks . '><label for="PROXY socks"></label><span>socks</span>
		</td>
	</tr>
	<tr>
		<td class="key"><a href="#">TIMEOUT</a></td>
		<td class="value"><input type="text" name="TIMEOUT" value="' . $this->F->config['TIMEOUT'] . '" onchange="SetConfig(this)"><i class="status"></i></td>
	</tr>
</table>';
		echo $html;
	}

	function SetConfig($data)
	{
		$config = $this->F->config;
		$key = array_keys($data);
		
		foreach ($config as $key => $value)
		{
			if (isset($data[$key]) && !empty($data[$key]))
			{
				$config[$key] = $data[$key];
			}
		}
		
		$data = array();
		foreach ($config as $key => $value)
		{
			$data[] = $key . ' = ' . $value;
		}

		file_put_contents($this->F->path . 'config.ini', implode("\r\n", $data));
	}

	function GetPlugins()
	{
		$html = '';
		$content = file_get_contents('content/plugins.json');
		
		$array = json_decode($content, true);
		asort($array);
		
		foreach ($array as $category => $plugins)
		{
			$category = strtoupper($category);
			$html .= '			<a class="param" href="#">' . $category . '</a>
			<div>
				<ul>';
			array_multisort($plugins, SORT_ASC);
			foreach ($plugins as $plugin => $data)
			{
				if (in_array($plugin, explode(' ', $this->F->config[$category])))
				{
					$checked = 'checked';
				}
				else
				{
					$checked = '';
				}
				
				$html .= '					<li><input id="' . $plugin . '" class="checkbox" type="checkbox" name="' . $category . '" value="' . $plugin 
					  . '" ' . $checked . ' onchange="SetPlugin(this);"><label for="' . $plugin . '"></label><i class="status ' . $data['status'] . '"></i><span>' 
					  . $plugin . '</span><i class="time">' . $data['time'] . '</i></li>';
			}

			$html .= '				</ul>
			</div>';
		}

		echo $html;
	}

	function SetPlugin($plugin)
	{
		$key = strtoupper(array_shift(array_keys($plugin)));
		$value = array_shift(array_values($plugin));
		$config = $this->F->config;
		
		if (is_int(strpos($config[$key], $value)))
		{
			$config[$key] = str_replace($value, '', $config[$key]);
		}
		else
		{
			$config[$key] .= ' ' . $value;
		}
		
		$data = array();
		
		
		
		$config[$key] = trim(preg_replace('|[\s]+|', ' ', $config[$key]));
		
		foreach ($config as $key => $value)
		{
			$data[] = $key . ' = ' . $value;
		}

		file_put_contents($this->F->path . 'config.ini', implode("\r\n", $data));
	}

	function GetProxies()
	{
		$file = 'content/proxies.txt';

		if (file_exists($file) && 0 < filesize($file))
		{
			$handle = fopen($file, 'r');

			while (!feof($handle))
			{
				$proxy = trim(fgets($handle));

				if (!empty($proxy))
				{
					echo ($proxy . "\r\n");
					continue;
				}
			}
			fclose($handle);
		}
	}

	function SetProxies($proxies)
	{
		file_put_contents('content/proxies.txt', $proxies);
	}

	function GetInterfaces()
	{
		$file = 'content/interfaces.txt';

		if (file_exists($file) && 0 < filesize($file))
		{
			$handle = fopen($file, 'r');

			while (!feof($handle))
			{
				$interface = trim(fgets($handle));

				if (!empty($interface))
				{
					echo ($interface . "\r\n");
					continue;
				}
			}

			fclose($handle);
		}
	}

	function SetInterfaces($interfaces)
	{
		file_put_contents('content/interfaces.txt', $interfaces);
	}

	function GetWords()
	{
		$file = 'content/stop-words.txt';

		if (file_exists($file) && 0 < filesize($file))
		{
			$handle = fopen($file, 'r');

			while (!feof($handle))
			{
				$word = trim(fgets($handle));

				if (!empty($word))
				{
					echo ($word . "\r\n");
					continue;
				}
			}
			fclose($handle);
		}
	}

	function SetWords($words)
	{
		file_put_contents('content/stop-words.txt', $words);
	}

	function GetCounter()
	{
		$file = $this->F->path . 'liveinternet.php';

		if (file_exists($file) && 0 < filesize($file))
		{
			$content = file_get_contents($file);
			echo $content;
		}
	}

	function SetCounter($counter)
	{
		if (!empty($counter))
		{
			$file = $this->F->path . 'liveinternet.php';
			file_put_contents($file, ($counter . "\r\n"));
		}
	}

	function GetUrls()
	{
		$file = $this->F->path . 'urls.txt';

		if (file_exists($file) && 0 < filesize($file))
		{
			$content = file_get_contents($file);
			echo $content;
		}
	}

	function SetUrls($urls)
	{
		if (!empty($urls))
		{
			$file = $this->F->path . 'urls.txt';
			file_put_contents($file, ($urls . '
			'));
		}
	}

	function GetTenDomains()
	{
		$domain = $this->F->Domain();
		$content = $this->F->Content('content/domains.txt');
		
		$domains = array_unique($content);
		array_push($domains, $domain);
		array_push($domains, 'default');
		
		foreach ($domains as  $d => $domain)
		{
			if ($d < 12)
			{
				echo '	<li><span onclick="GetDomain(this);">' . $domain . '</span></li>';
				continue;
			}
		}

		echo '	<li><span onclick="GetAllDomains();">All domains</span></li>';
	}

	function GetAllDomains()
	{
		$domains = $this->F->Content('content/domains.txt');
		foreach ($domains as $domain)
		{
			echo '	<li>
		<i class="status fail" title="Remove domain ' . $domain . '" onclick="RemoveDomain(this);"></i>
		<span onclick="GetDomain(this);">' . $domain . '</span>
	</li>';
		}
	}

	function GetArchive($archive)
	{
		switch ($archive)
		{
			case 'domains.zip':
				$zip = 'content/' . $archive;
				break;
			default:
				$zip = $this->F->path . $archive;
				break;
		}

		if (file_exists($zip))
		{
			echo '	<span>Download archive: <a href="' . $zip . '">' . $archive . '</a><i class="status fail" title="Remove archive ' . $archive 
				. '" onclick="RemoveArchive(this);"></i></span>';
		}
	}

	function RemoveArchive($archive)
	{
		switch ($archive)
		{
			case 'domains.zip':
				$zip = 'content/' . $archive;
				break;
			default:
				$zip = $this->F->path . $archive;
				break;
		}

		if (file_exists($zip))
		{
			unlink($zip);
		}
	}

	function RemoveDomain($domain)
	{
		$file = 'content/domains.txt';
		$domains = $this->F->Content($file);
		$key = array_search($domain, $domains);
		unset($domains[$key]);
		file_put_contents($file, implode("\r\n", $domains) . "\r\n");
	}

	function Generator($file)
	{
		if (file_exists($file) && 0 < filesize($file))
		{
			$zip = $this->F->path . 'keywords.zip';
			$this->Z->open($zip, ZipArchive::CREATE);
			$this->Z->addFile($file, 'keywords.txt');
			$this->Z->close();

			if (!is_dir('content/urls'))
			{
				mkdir('content/urls', 493);
			}

			$handle = fopen($file, 'r');

			while (!feof($handle))
			{
				$keyword = trim(fgets($handle));

				if (!empty($keyword))
				{
					$json = $this->F->JSON($keyword);
					$obj = json_decode($json);
					$file = $this->F->path . 'content/base/' . $obj->md5[0] . '/' . $obj->md5[1] . '.txt';
					file_put_contents($file, ($json . "\r\n"), FILE_APPEND | LOCK_EX);
					$url = $this->F->CreateUrl($this->F->config['ROUTE'] . '/' . $obj->query);
					$href = ($url . "\r\n");
					$html = '<a href="' . $url . '">' . $obj->query . '</a>' . "\r\n";
					$code = '[url=' . $url . ']' . $obj->query . '[/url]' . "\r\n";
					$farm =  $url . ' ' . $obj->query . '' . "\r\n";
					file_put_contents('content/urls/href.txt', $href, FILE_APPEND | LOCK_EX);
					file_put_contents('content/urls/html.txt', $html, FILE_APPEND | LOCK_EX);
					file_put_contents('content/urls/code.txt', $code, FILE_APPEND | LOCK_EX);
					file_put_contents('content/urls/farm.txt', $farm, FILE_APPEND | LOCK_EX);
					continue;
				}
			}
			fclose($handle);

			if (in_array('dom', get_loaded_extensions()))
			{
				$xml = new DOMDocument('1.0', 'UTF-8');
				$xml->formatOutput = true;
				$uri = $xml->appendChild($xml->createElementNS('http://www.sitemaps.org/schemas/sitemap/0.9', 'urlset'));
				$file = 'content/urls/href.txt';

				if (file_exists($file) && 0 < filesize($file))
				{
					$handle = fopen($file, 'r');
					while (!feof($handle))
					{
						$url = trim(fgets($handle));
						if (!empty($url))
						{
							$urn = $uri->appendChild($xml->createElement('url'));
							$loc = $urn->appendChild($xml->createElement('loc'));
							$loc->appendChild($xml->createTextNode($url));
							continue;
						}
					}
					fclose($handle);
					$xml->save($this->F->path . 'sitemap.xml');
				}
			}

			$zip = $this->F->path . 'urls.zip';
			$this->Z->open($zip, ZipArchive::CREATE);
			$this->Z->addFile('content/urls/href.txt', 'href.txt');
			$this->Z->addFile('content/urls/html.txt', 'html.txt');
			$this->Z->addFile('content/urls/code.txt', 'code.txt');
			$this->Z->addFile('content/urls/farm.txt', 'farm.txt');
			$this->Z->close();

			if (!file_exists($zip))
			{
				$this->F->Error('Can\'t create or write in file ' . $zip . '.');
			}
			else
			{
				$this->F->RemoveDirectory('content/urls');
			}

			$keys = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f');
			$i = 0;
			while ($i < count($keys))
			{
				$j = 0;
				while ($j < count($keys))
				{
					$file = $this->F->path . 'content/base/' . $keys[$i] . '/' . $keys[$j] . '.txt';
					$keywords = $this->F->Content($file);

					if (!empty($keywords))
					{
						file_put_contents($file, implode("\r\n", array_unique($keywords)) . "\r\n");
					}
					++$j;
				}
				++$i;
			}
			echo '	<i class="status okay"></i><span>Keywords added to queries base. Download archive: <a href="' . $zip . '">urls.zip</a>.</span>';
			return null;
		}

		echo '	<i class="status fail"></i><span>Keywords file can\'t be empty.</span>';
		$this->F->Error('Keywords file can\'t be empty.');
	}

	function Filter()
	{
		if (!is_dir('content/keywords'))
		{
			mkdir('content/keywords', 493);
		}

		$word = '';
		$file = 'content/stop-words.txt';

		if (file_exists($file) && 0 < filesize($file))
		{
			$words = array();
			$handle = fopen($file, 'r');
			
			while (!feof($handle))
			{
				$word = trim(fgets($handle));

				if (!empty($word))
				{
					if (preg_match('|^[*]|', $word))
					{
						$word = str_replace('*', '', $word) . '$';
					}

					if (preg_match('|[*]$|', $word))
					{
						$word = '^' . str_replace('*', '', $word);
					}
				}
				$words[] = $word;
			}
			fclose($handle);
			$word = implode('|', $words);
		}

		$keys = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f');
		$i = 0;

		while ($i < count($keys))
		{
			$j = 0;
			while ($j < count($keys))
			{
				$file = $this->F->path . 'content/base/' . $keys[$i] . '/' . $keys[$j] . '.txt';

				if (file_exists($file) && 0 < filesize($file))
				{
					$strings = array();
					$handle = fopen($file, 'r');
					while (!feof($handle))
					{
						$string = trim(fgets($handle));
						if (!empty($string))
						{
							$query = json_decode($string)->query;
							if (!empty($word))
							{
								$pattern = mb_strtolower($word, 'UTF-8');
								$subject = mb_strtolower($query, 'UTF-8');
								if (!preg_match('/' . $pattern . '/', $subject))
								{
									$strings[] = $string;
									file_put_contents('content/keywords/keywords.txt', ($query . "\r\n"), FILE_APPEND | LOCK_EX);
									continue;
								}
								continue;
							}
							file_put_contents('content/keywords/keywords.txt', ($query . "\r\n"), FILE_APPEND | LOCK_EX);
							continue;
						}
					}
					fclose($handle);
					
					if (!empty($strings))
					{
						file_put_contents($file, implode("\r\n", $strings) . "\r\n");
					}
				}
				++$j;
			}
			++$i;
		}
		
		$zip = $this->F->path . 'keywords.zip';
		$this->Z->open($zip, ZipArchive::CREATE);
		$this->Z->addFile('content/keywords/keywords.txt', 'keywords.txt');
		$this->Z->close();

		if (!file_exists($zip))
		{
			$this->F->Error('Can\'t create or write in file keywords.zip in the content directory.');
			return null;
		}

		$this->F->RemoveDirectory('content/keywords');
		echo '	<i class="status okay"></i>
		<span>Keywords in the queries base were filtered. Download archive: <a href="' . $zip . '">keywords.zip</a>.</span>';
	}

	function Cleaner($directory)
	{
		$this->F->RemoveDirectory($this->F->path . 'content/' . $directory);

		if (!is_dir($this->F->path . 'content/' . $directory))
		{
			echo '	<i class="status okay"></i>
			<span>Directory ' . $directory . ' was successfully removed.</span>';
		}
	}

	function Pluginer($category, $plugin)
	{
		$start = microtime(true);
		$o = $this->F->GetObject($plugin, $category);
		switch ($category)
		{
			case in_array($category, array('images', 'snippets', 'videos')):
				$res = $o->Start($this->F, 'internet', 1);
				break;
			case 'comments':
				$res = $o->Start($this->F);
				break;
			case 'pingers':
				$url = $this->F->CreateUrl('default/internet');
				$res = $o->Start($this->F, 'internet', $url);
				break;
		}

		$end = microtime(true);
		$time = round($end - $start, 2);
		$plugins = json_decode(file_get_contents('content/plugins.json'), true);

		if (!empty($res))
		{
			$plugins[$category][$plugin] = array('time' => $time . ' s.', 'status' => 'okay');
		}
		else
		{
			$plugins[$category][$plugin] = array('time' => $time . ' s.', 'status' => 'fail');
		}

		file_put_contents('content/plugins.json', json_encode($plugins));
		echo '	<i class="status okay"></i>
		<span>
		<a onclick="GetPlugins();">Show result</a>
		</span>';
	}

	function Kinder($domains, $folder)
	{
		$txt = 'content/domains.txt';

		if (!empty($domains))
		{
			file_put_contents($txt, ($domains . "\r\n"), FILE_APPEND | LOCK_EX);
		}

		$zip = 'content/domains.zip';
		$this->Z->open($zip,  ZipArchive::CREATE);
		$domains = $this->F->Content($txt);
		foreach ($domains as $domain)
		{
			$index = '' . 
'<?php
$id = isset($_GET[\'id\']) ? $_GET[\'id\'] : \'\';
$query = isset($_POST[\'query\']) ? $_POST[\'query\'] : \'\';

$ch = curl_init();
$url = "' . $this->F->host . '/$id";
$data = array(
	\'domain\' => ' . $domain . ',
	\'query\' => \$query
);
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
$html = curl_exec($ch);
$code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
$type = curl_getinfo($ch, CURLINFO_CONTENT_TYPE);
curl_close($ch);

if($code == \'404\')
{
	header("HTTP/1.0 404 Not Found");
}

header("Content-Type: $type");
echo $html;
';
			
			$robots = '' . 
'User-agent: Yandex
Disallow:
Crawl-delay: 5
			
User-agent: Googlebot
Disallow:

User-agent: *
Crawl-delay: 10
Disallow: /

Sitemap: http://' . $domain . '/sitemap.xml';
			
			$base = strpos($domain, '/');
			$base = (!empty($base) ? $base : '/');
			$htaccess = '' . 
'RewriteEngine On
RewriteBase ' . $base . '

RewriteCond %{REQUEST_FILENAME} !-d
RewriteCond %{REQUEST_FILENAME} !-f

RewriteRule index.php.* - [L]

RewriteCond %{REQUEST_FILENAME} !-d
RewriteCond %{REQUEST_FILENAME} !-f

RewriteRule ^(.*) index.php?id=$1';
			
			$this->Z->addFromString($domain . '/' . $folder . 'index.php', $index);
			$this->Z->addFromString($domain . '/' . $folder . 'robots.txt', $robots);
			$this->Z->addFromString($domain . '/' . $folder . '.htaccess', $htaccess);
			$xml = 'domains/' . $domain . '/sitemap.xml';

			if (file_exists($xml))
			{
				$this->Z->addFile($xml, $domain . '/' . $folder . 'sitemap.xml');
				continue;
			}
		}

		$this->Z->close();

		if (!file_exists($zip))
		{
			$this->F->Error('Can\'t create or write in file domains.zip in the content directory.');
			return null;
		}

		echo '	<i class="status okay"></i><span>All domains were created. Download archive: <a href="content/domains.zip">domains.zip</a>.</span>';
	}
}
?>