<?php
class Conduit
{
	function Start($F, $string, $count)
	{		
		$snippets = array();
		$query = urlencode(mb_strtolower($string, 'UTF-8'));
		$url = 'http://search.conduit.com/Results.aspx?q=' . $query . '&lr=lang_' . $F->config['LANGUAGE'] . '&ie=utf-8&oe=utf-8';
		$html = $F->GetHTML($url);

		if (!is_bool($html))
		{
			$i = 0;
			foreach ($html->find('div[id="organic_results"] div[class="ads_wrapper"]') as $e)
			{
				$t = 'div[class="title"] a';
				$d = 'span[class="text"] span';

				if (isset($e->find($t, 0)->plaintext))
				{
					$title = $e->find($t, 0)->plaintext;
				}

				if (isset($e->find($d, 0)->plaintext))
				{
					$description = $e->find($d, 0)->plaintext;
				}

				if ($i < $count)
				{
					if (!empty($title) && !empty($description))
					{
						$snippets[$i]['title'] = trim($title);
						$snippets[$i]['description'] = trim($description);
						++$i;
						continue;
					}

					continue;
				}
			}
			$html->clear();
		}
		else
		{
			$F->Error('Can\'t create outgoing request. Please check Conduit snippets plugin.');
		}

		return $snippets;
	}
}
?>