<?php
class Rambler
{
	function Start($F, $string, $count)
	{		
		$snippets = array();
		$query = urlencode(mb_strtolower($string, 'UTF-8'));
		$url = 'http://nova.rambler.ru/search?query=' . $query;
		$html = $F->GetHTML($url);

		if (!is_bool($html))
		{
			$i = 0;
			foreach ($html->find('li[class="b-serp__list_item"]') as $e)
			{
				$t = 'h2[class="b-serp__list_item_title"]';
				$d = 'p[class="b-serp__list_item_snippet"]';

				if (isset($e->find($t, 0)->plaintext))
				{
					$title = $e->find($t, 0)->plaintext;
				}

				if (isset($e->find($d, 0)->plaintext))
				{
					$description = $e->find($d, 0)->plaintext;
				}

				if ($i < $count)
				{
					if (!empty($title) && !empty($description))
					{
						$snippets[$i]['title'] = trim($title);
						$snippets[$i]['description'] = trim($description);
						++$i;
						continue;
					}
					continue;
				}
			}
			$html->clear();
		}
		else
		{
			$F->Error('Can\'t create outgoing request. Please check Rambler snippets plugin.');
		}
		return $snippets;
	}
}
?>