<?php
class Ukr
{
	function Start($F, $string, $count)
	{
		$snippets = array();
		$query = urlencode(mb_strtolower($string, 'UTF-8'));
		$url = 'http://search.ukr.net/yandex/search.php?search_mode=ordinal&lang=' . $F->config['LANGUAGE'] . '&engine=1&search_query=' . $query . '&q=' . $query;
		$html = $F->GetHTML($url);

		if (!is_bool($html))
		{
			$i = 0;
			foreach ($html->find( 'ol[class="results"] li' ) as $e)
			{
				$t = 'div[class="title"] a';
				$d = 'div[class="text"]';

				if (isset($e->find( $t, 0 )->plaintext))
				{
					$title = $e->find($t, 0)->plaintext;
				}

				if (isset($e->find($d, 0)->plaintext))
				{
					$description = $e->find($d, 0)->plaintext;
				}

				if ($i < $count)
				{
					if (!empty($title) && !empty($description))
					{
						$snippets[$i]['title'] = trim($title);
						$snippets[$i]['description'] = trim($description);
						++$i;
						continue;
					}
					continue;
				}
			}
			$html->clear();
		}
		else
		{
			$F->Error('Can\'t create outgoing request. Please check Ukr snippets plugin.');
		}
		return $snippets;
	}
}
?>