<?php
require_once( 'base.php' );

class Ajax extends Base
{
	function __construct()
	{
		parent::__construct();
		$this->key = false;
		$this->auth = true;
	}

	function OnInput()
	{
		parent::oninput();

		if ($this->IsPost())
		{
			$A = mAjax::instance();
			$route = $this->F->GetRoute($_SERVER['REQUEST_URI']);
			
			switch ($route->action)
			{
				case 'get':
				{
					switch ($route->content)
					{
						case 'config':
						{
							$A->GetConfig();
							break;
						}
						case 'plugins':
						{
							$A->GetPlugins();
							break;
						}
						case 'proxies':
						{
							$A->GetProxies();
							break;
						}
						case 'interfaces':
						{
							$A->GetInterfaces();
							break;
						}
						case 'tendomains':
						{
							$A->GetTenDomains();
							break;
						}
						case 'alldomains':
						{
							$A->GetAllDomains();
							break;
						}
						case 'archive':
						{
							$A->GetArchive($_POST['archive']);
							break;
						}
						case 'counter':
						{
							$A->GetCounter();
							break;
						}

						case 'urls':
						{
							$A->GetUrls();
							break;
						}
						case 'words':
						{
							$A->GetWords();
						}
					}
					break;
				}
				case 'set':
				{
					switch ($route->content)
					{
						case 'config':
						{							
							$A->SetConfig($_POST['config']);
							break;
						}
						case 'plugin':
						{
							$A->SetPlugin($_POST['plugin']);
							break;
						}
						case 'proxies':
						{
							$A->SetProxies($_POST['proxies']);
							break;
						}
						case 'interfaces':
						{
							$A->SetInterfaces($_POST['interfaces']);
							break;
						}
						case 'counter':
						{
							$A->SetCounter($_POST['counter']);
							break;
						}
						case 'urls':
						{
							$A->SetUrls($_POST['urls']);
							break;
						}
						case 'words':
						{
							$A->SetWords($_POST['words']);
							break;
						}
					}
					break;
				}
				case 'utils':
				{
					switch ($route->content)
					{
						case 'generator':
						{
							$A->Generator($_FILES['keywords']['tmp_name']);
							break;
						}
						case 'filter':
						{
							$A->Filter();
							break;
						}
						case 'cleaner':
						{
							$A->Cleaner($_POST['directory']);
							break;
						}
						case 'pluginer':
						{
							$A->Pluginer($_POST['category'], $_POST['plugin']);
							break;
						}
						case 'kinder':
						{
							$A->Kinder($_POST['domains'], $_POST['folder']);
							break;
						}
					}
					break;
				}
				case 'remove':
				{
					switch ($route->content)
					{
						case 'archive':
						{
							$A->RemoveArchive($_POST['archive']);
							break;
						}
						case 'domain':
						{
							$A->RemoveDomain($_POST['domain']);
							break;
						}
					}
					break;
				}
			}
		}

	}

	function OnOutput()
	{
	
	}
}
?>