<?php
require_once( 'base.php' );

class Home extends Base
{
	function __construct()
	{
		parent::__construct();
		$this->key = true;
		$this->auth = false;
	}

	function OnInput()
	{
		parent::OnInput();
		
		if (!empty($this->F->config['KEYWORD']))
		{
			$query = $this->F->config['KEYWORD'];
		}
		else
		{
			$query = $this->F->Query();
		}
		
		$elements = array();

		if (!empty($query))
		{
			$elements = $this->F->Run($query);
		}

		$this->T = mTemp::instance($query, $elements);
	}

	function OnOutput()
	{
		$this->content = $this->Template('home', array('T' => $this->T));
		parent::onoutput();
	}
}
?>