<?php
class Ask
{
	function Start($F, $string, $count)
	{
		$snippets = array();
		$query = urlencode(mb_strtolower($string, 'UTF-8'));
		$url = 'http://www.ru.ask.com/web?q=' . $query . '&ie=utf-8&oe=utf-8';
		$html = $F->GetHTML($url);

		if (!is_bool($html))
		{
			$i = 0;
			foreach ($html->find('div[id="lindm"] div[class="tsrc_tled"]') as $e)
			{
				$t = 'div[class="ptbs"] div a';
				$d = 'div[class="ptbs"] div[class="txt3 abstract"]';

				if (isset($e->find($t, 0)->plaintext))
				{
					$title = htmlentities($e->find($t, 0)->plaintext, ENT_QUOTES, 'UTF-8');
				}

				if (isset($e->find($d, 0)->plaintext))
				{
					$description = htmlentities($e->find($d, 0)->plaintext, ENT_QUOTES, 'UTF-8');
				}

				if ($i < $count)
				{
					if ((!empty($title) && !empty($description)))
					{
						$snippets[$i]['title'] = htmlspecialchars_decode($title);
						$snippets[$i]['description'] = htmlspecialchars_decode($description);
						++$i;
						continue;
					}

					continue;
				}
			}

			$html->clear();
		}
		else
		{
			$F->Error('Can\'t create outgoing request. Please check Ask snippets plugin.');
		}

		return $snippets;
	}
}
?>