<?php
	session_start(  );
	ini_set( 'max_execution_time', 0 );

	if (file_exists( 'redsed.php' )) {
		include_once( 'redsed.php' );
	}

	require_once( 'application/controllers/rss.php' );
	require_once( 'application/controllers/ajax.php' );
	require_once( 'application/controllers/home.php' );
	require_once( 'application/controllers/admin.php' );
	require_once( 'application/controllers/image.php' );
	require_once( 'application/controllers/login.php' );
	require_once( 'application/controllers/result.php' );
	require_once( 'application/controllers/custom.php' );
	define( 'VERSION', '3.5.3.2' );
	$F = mFunc::instance(  );
	$page = $F->GetController( $_SERVER['REQUEST_URI'] );

	if (!empty( $page )) {
		$F->Redirect( $_SERVER['REQUEST_URI'] );
		$pages = $F->GetPages(  );
		switch ($page) {
			case 'rss': {
				$controller = new Rss(  );
				break;
			}

			case 'ajax': {
				$controller = new Ajax(  );
				break;
			}

			case 'admin': {
				$controller = new Admin(  );
				break;
			}

			case 'image': {
				$controller = new Image(  );
				break;
			}

			case 'login': {
				$controller = new Login(  );
				break;
			}

			case in_array( $page, $pages ): {
				$controller = new Custom(  );
				break;
			}

			default: {
				$controller = new Result(  );
				break;
			}
		}
	} else {
		$controller = new Home(  );
	}

	$controller->Request(  );
?>